﻿/**
* ベジェ曲線変換
* @author nutsu
*/

package {
	
	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getTimer;
	
	import com.nutsu.shape.*;
	
	public class BezierConvertTest extends MovieClip{
		
		//始点
		private var handle_start:Sprite;
		//終点
		private var handle_end:Sprite;
		//コントロール点
		private var handle_ctrl0:Sprite;
		//コントロール点
		private var handle_ctrl1:Sprite;
		
		//編集中か
		private var now_editting:Boolean = false;
		private var edit_handle:Sprite;
		
		private var gc2:Graphics;
		
		/**
		* コンストラクタ
		*/
		public function BezierConvertTest(){
			super();
			
			//表示要素初期化
			handle_start = makeHandle();
			handle_end   = makeHandle();
			handle_ctrl0 = makeHandle();
			handle_ctrl1 = makeHandle();
			
			addChild( handle_start );
			addChild( handle_end );
			addChild( handle_ctrl0 );
			addChild( handle_ctrl1 );
			
			//初期位置
			handle_start.x = 75;
			handle_start.y = 250;
			handle_end.x = 350;
			handle_end.y = 250;
			handle_ctrl0.x = 100;
			handle_ctrl0.y = 120;
			handle_ctrl1.x = 325;
			handle_ctrl1.y = 120;
			
			//
			gc2 = Shape( addChild( new Shape() ) ).graphics;
			
			draw();
			
			edit_handle = handle_start;
			stage.addEventListener( MouseEvent.MOUSE_UP, stopEdit );
			stage.addEventListener( MouseEvent.MOUSE_MOVE, update );
			
		}
		
		/**
		*	描画
		*/
		private function draw():void{
			graphics.clear();
			
			//補助線
			graphics.lineStyle( 0, 0x666666 );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.lineTo( handle_ctrl0.x, handle_ctrl0.y );
			graphics.lineTo( handle_ctrl1.x, handle_ctrl1.y );
			graphics.lineTo( handle_end.x, handle_end.y );
			
			
			//本物3次元ベジェ
			var bezier:CBezier = new CBezier( handle_start.x, handle_start.y,
											  handle_end.x, handle_end.y,
											  handle_ctrl0.x, handle_ctrl0.y,
											  handle_ctrl1.x, handle_ctrl1.y );
			
			//CONVERT
			var qbs:Array  = BezierConvert.C2Q(bezier);
			
			graphics.lineStyle( 3, 0xff6600 );
			for( var i:int=0; i<qbs.length; i++ ){
				qbs[i].draw( graphics );
			}
			
			graphics.lineStyle( 1, 0x000000 );
			bezier.draw(graphics);
			
			gc2.clear();
			for( var j:int=0; j<qbs.length-1; j++ ){
				gc2.beginFill( 0xffffff );
				gc2.drawCircle( qbs[j].point1.x,qbs[j].point1.y, 3 );
				gc2.endFill();
			}
		}
		
		
		/**
		* リスナ
		*/
		private function startEdit( e:MouseEvent ):void{
			now_editting = true;
			edit_handle = (e.target as Sprite);
			edit_handle.startDrag(false, new Rectangle(0,0,stage.stageWidth,stage.stageHeight));
		}
		
		private function stopEdit( e:MouseEvent ):void{
			now_editting = false;
			edit_handle.stopDrag();
			draw();
		}
		
		private function update( e:MouseEvent ):void{
			if( now_editting ) draw();
		}
		
		/**
		* ハンドル生成
		*/
		private function makeHandle():Sprite{
			var s:Sprite;
			(s = new Sprite()).addChild( makePointShape( 0xffffff, 4 ) );
			s.addEventListener( MouseEvent.MOUSE_DOWN, startEdit );
			s.buttonMode = true;
			return s;
		}
		
		/**
		* ポイント用Shape
		*/
		private function makePointShape(col:uint, size:Number):Shape{
			var d:Shape = new Shape();
			d.graphics.clear();
			d.graphics.beginFill( col );
			d.graphics.drawCircle( 0, 0, size );
			d.graphics.endFill();
			return d;
		}
	}
	
}

