﻿/**
* 線分
* @author nutsu
* @version 0.1
*/

package com.nutsu.geom{
	
	import flash.display.Graphics;
	import flash.geom.Point;

	public class Line{
		
		public var point0:Point;
		public var point1:Point;
		
		/**
		* Constructor
		*/
		public function Line( p0:Point, p1:Point ){
			point0 = p0;
			point1 = p1;
		}
		
		public function get f():LineF{
			return LineF.makeBy2Point(point0, point1);
		}
		
		//-----------------------------------------------------------------------INTERSECTION
		
		/**
		* 交点
		* @param	Line
		* @return	Point
		*/
		public function intersection( sl:Line ):Point{
			var p:Point = f.intersection( sl.f );
			if( p != null ){
				if( ((p.x-point0.x)*(p.x-point1.x)+(p.y-point0.y)*(p.y-point1.y))<=0 ){
					return p;
				}else{
					return null;
				}
			}else{
				return null;
			}
		}
		
		//-----------------------------------------------------------------------GRAPHICS
		public function draw(g:Graphics):void{
			g.moveTo( point0.x, point0.y );
			g.lineTo( point1.x, point1.y );
		}
		
		//-----------------------------------------------------------------------TRACE
		public function toString():String{
			return "[Line " + point0 + ", " + point1 + " ]";
		}
	}
	
}
